﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Xamarin.Forms;

namespace ScheduleGettingStarted
{
	public class ViewModel : ContentPage
	{
		public ObservableCollection<Meeting> ListOfMeeting = new ObservableCollection<Meeting>();

		public ViewModel()
		{
			ListOfMeeting = new ObservableCollection<Meeting>();
			InitializeDataForBookings();
			BookingAppointments();
		}

		#region BookingAppointments

		private void BookingAppointments()
		{
			Random randomTime = new Random();
			List<Point> randomTimeCollection = GettingTimeRanges();

			DateTime date;
			DateTime DateFrom = DateTime.Now.AddDays(-10);
			DateTime DateTo = DateTime.Now.AddDays(10);
			DateTime dateRangeStart = DateTime.Now.AddDays(-3);
			DateTime dateRangeEnd = DateTime.Now.AddDays(3);

			for (date = DateFrom; date < DateTo; date = date.AddDays(1))
			{
				if ((DateTime.Compare(date, dateRangeStart) > 0) && (DateTime.Compare(date, dateRangeEnd) < 0))
				{
					for (int AdditionalAppointmentIndex = 0; AdditionalAppointmentIndex < 3; AdditionalAppointmentIndex++)
					{
						Meeting meeting = new Meeting();
						int hour = (randomTime.Next((int)randomTimeCollection[AdditionalAppointmentIndex].X, (int)randomTimeCollection[AdditionalAppointmentIndex].Y));
						meeting.From = new DateTime(date.Year, date.Month, date.Day, hour, 0, 0);
						meeting.To = (meeting.From.AddHours(1));
						meeting.EventName = meeting_collection[randomTime.Next(9)];
						meeting.color = color_collection[randomTime.Next(9)];
						ListOfMeeting.Add(meeting);
					}
				}
				else
				{
					Meeting meeting = new Meeting();
					meeting.From = new DateTime(date.Year, date.Month, date.Day, randomTime.Next(9, 11), 0, 0);
					meeting.To = (meeting.From.AddHours(1));
					meeting.EventName = meeting_collection[randomTime.Next(9)];
					meeting.color = color_collection[randomTime.Next(9)];
					ListOfMeeting.Add(meeting);
				}
			}
		}

		#endregion BookingAppointments


		List<string> meeting_collection;
		List<Color> color_collection;

		#region InitializeDataForBookings

		private void InitializeDataForBookings()
		{
			meeting_collection = new List<string>();
			meeting_collection.Add("GeneralMeeting");
			meeting_collection.Add("Plan Execution");
			meeting_collection.Add("Project Plan");
			meeting_collection.Add("Consulting");
			meeting_collection.Add("Performance Check");
			meeting_collection.Add("Yoga Therapy");
			meeting_collection.Add("Plan Execution");
			meeting_collection.Add("Project Plan");
			meeting_collection.Add("Consulting");
			meeting_collection.Add("Performance Check");

			color_collection = new List<Color>();
			color_collection.Add(Color.FromHex("#117EB4"));
			color_collection.Add(Color.FromHex("#B4112E"));
			color_collection.Add(Color.FromHex("#C44343"));
			color_collection.Add(Color.FromHex("#11B45E"));
			color_collection.Add(Color.FromHex("#43BEC4"));
			color_collection.Add(Color.FromHex("#B4112E"));
			color_collection.Add(Color.FromHex("#C44343"));
			color_collection.Add(Color.FromHex("#117EB4"));
			color_collection.Add(Color.FromHex("#C4435A"));
			color_collection.Add(Color.FromHex("#DF5348"));
			color_collection.Add(Color.FromHex("#43c484"));
		}

		#endregion InitializeDataForBookings

		#region GettingTimeRanges

		private List<Point> GettingTimeRanges()
		{
			List<Point> randomTimeCollection = new List<Point>();
			randomTimeCollection.Add(new Point(9, 11));
			randomTimeCollection.Add(new Point(12, 14));
			randomTimeCollection.Add(new Point(15, 17));

			return randomTimeCollection;
		}

		#endregion GettingTimeRanges

	}
}

